

#    These procedures are used by all 


    proc InsertLog {s} {
        variable LogText
        variable LogCount
        variable LogFlag
        variable ShowLogFlag
        variable JS

        if {$LogFlag == 1 && $ShowLogFlag == 1} {

            incr LogCount
            if {$LogCount == 1000} {EmptyLog}

            set LogText "$s\n[set LogText]"
        } else {
            if {$JS == ""} {append JS "alert(\""}
            append JS "[string map {\" \\" \n \\n} $s]\\n"
        }
        return ""
    }

    proc EmptyLog {} {
        variable LogText
        variable LogCount
        variable LogFlag
        variable ShowLogFlag
        variable JS

        if {$LogFlag == 1 && $ShowLogFlag == 1} {

            set LogText ""
            set LogCount 0
        } else {
            set JS ""
        }
    }

    proc Alert {s} {
        variable JS

        if {$JS == ""} {append JS "alert(\""}
        append JS "[string map {\" \\" \n \\n} $s]\\n"
    }

    proc Confirm {t s} {
        variable JS

       if {$JS != ""} {append JS "\");"}
        append JS "if (confirm(\"[string map {\" \\" \n \\n} $s]\\n\\n\\nAre you sure you wish to continue?\")) \
            {click_CONFIRM(document.$t);}"

       append JS "(\""

    }

   proc do_help {} {
      variable HelpTopic 

        set Txtfile [file join $HelpTopic.txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Sorry unable to access $Txtfile\nInformation coming very soon!!\n"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }

    proc PrintLog {} {
        variable LogText

     if {[info procs ::DefineMessage] != "::DefineMessage"} {puts "DefineMessage unknown\n"; return}

        ::DefineMessage -c digitizer -l INFORMATION  "$LogText"
    }

    proc Elog {l s} {

     if {[info procs ::DefineMessage] != "::DefineMessage"} {puts "DefineMessage unknown\n"; return}

        ::DefineMessage -c digitizer -l $l  "$s"
    }

